#ifndef __cinvoker_inc__
#define __cinvoker_inc__

struct GUID,1 {
 int data1;
 word data2;
 word data3;
 byte data4[8];
}

struct SAFEARRAYBOUND
{
   unsigned int cElements;
   int lLbound;
}
struct SAFEARRAY
{
    unsigned word cDims;
    unsigned word fFeatures;
    unsigned int  cbElements;
    unsigned int  cLocks;
    void *pvData;
    SAFEARRAYBOUND rgsabound[ 1 ];
}
struct CY
{
    int64 _int64[0];
	unsigned int Lo;
	int  Hi;
}

#typedef DATE double;
#typedef SCODE unsigned int


struct VARIANT,2 {
	word   vt; // type VT_BOOL ...
	word   Reserved[3];
	union {
		int64 llval;int lVal;unsigned byte bVal;word iVal;int scode;
		float fltVal;double dblVal;word boolVal;byte cVal;
		unsigned word uiVal;DWORD ulVal;unsigned int64 ullVal;
		wstring *bstrVal;pointer punkVal;pointer pdispVal;
		VARIANT* pvarVal;DATE date;double* pdate;
		void *ptr;unsigned byte *pbVal;int *plVal;int64 *pllVal;
		float *pfltVal;double *pdblVal;word *pboolVal;
		void *pscode;void *pbstrVal;
		void *ppunkVal;void *ppdispVal;
		void *pdecVal;byte *pcVal;unsigned word *puiVal;DWORD *pulVal;
		unsigned int64 *pullVal;int *pintVal;unsigned int *puintVal;
		int intVal;unsigned int uintVal;
		CY cyVal;CY *pcyVal;
	}
}

class CInvoker
{
private:
	declare CInvoker();
	declare _CInvoker();
	declare virtual QueryInterface(REFIID *riid,/*out*/void *ppvObject),int;
	declare virtual AddRef(),int;
	declare virtual Release(),int;
	declare virtual GetTypeInfoCount(int* pctinfo),int;
	declare virtual GetTypeInfo(UINT itinfo, ULONG lcid, void* pptinfo),int;
	declare virtual GetIDsOfNames(GUID* riid, wstring* rgszNames,int cNames,int lcid,int* rgdispid),int;
	declare virtual Invoke2(int dispidMember, GUID* riid, int lcid,word wFlags,pointer pdispparams,VARIANT* pvarResult,pointer pexcepinfo,int* puArgErr),int;

	declare Cleanup();
	declare CleanupRetval();
	declare GetMethodIndexAndID(wstring *wszMethodName, int *ppIndex, int *ppID),BOOL;
	declare CleanupDispParams(pointer dsp);
	declare FillDispParams(pointer dsp, void *argv, pointer pfd);
	declare Disconnect(),int;

public:
	declare Advise(opt string *pstrEventsName=NULL),BOOL;
	declare Create(wstring *progID),BOOL;
	declare Attach(pointer pDisp,opt pointer riid=NULL),BOOL;
	declare CreateFromResult(CInvoker *from),BOOL;
	declare GetInterfaceName(),heap;
	declare GetResultAsString(),heap;
	declare invoke(...),BOOL;
	declare get(...),BOOL;
	declare put(...),BOOL;
	declare putref(...),BOOL;

	declare GetInvokeArguments(wstring wszmethod),heap;
	declare GetErrorDesc(int hr),string;

	int     m_refs;
	pointer m_object;
	pointer m_pti;

	DWORD    m_ClsContext;
	int      m_lcid;
	DWORD    m_hr;

	int      m_idcnt;
	int     *m_pIDs;
	VARIANT  m_retval;

	pointer  m_ptidisp;
	DWORD    m_ConnectionCookie;
	pointer  m_pcp;
	pointer  m_ptattr;
	GUID     m_diid;
}
#endif

